
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>C#串口操作(国外网站看来的，共享一下) / iVAN</title>

    <meta name="description" content="C#串口操作(国外网站看来的，共享一下) 国外网站 前一阵,从国外网站看到一个用C#来操作串口的类.下载下来试了一下,觉得不错.共享一下./** Author: Marcus Lorentzon, 2001* d98malor@dtek.chalmers.se* * Freeware: Please do not remove this header* * File: SerialStream.cs* * Description: Implements a Stream for asynchronous* transfers and C">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">C#串口操作(国外网站看来的，共享一下)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>国外网站</p>
<p>前一阵，从国外网站看到一个用C#来操作串口的类。下载下来试了一下，觉得不错。共享一下。<br />/*<br />* Author: Marcus Lorentzon, 2001<br />*         d98malor@dtek.chalmers.se<br />* <br />* Freeware: Please do not remove this header<br />* <br />* File: SerialStream.cs<br />* <br />* Description: Implements a Stream for asynchronous<br />*              transfers and COMM. Stream version.<br />*<br />* Version: 2.4<br />* <br />*/</p>
<p>#region Using</p>
<p>using System;<br />using System.IO;<br />using System.Threading;<br />using System.Runtime.InteropServices;<br />using System.ComponentModel;</p>
<p>#endregion Using</p>
<p>namespace LoMaN.IO {</p>
<p>public class SerialStream : Stream {</p>
<p>#region Attributes</p>
<p>private IOCompletionCallback m_IOCompletionCallback;<br />        private IntPtr m_hFile = IntPtr.Zero;<br />        private string m_sPort;<br />        private bool m_bRead;<br />        private bool m_bWrite;</p>
<p>#endregion Attributes</p>
<p>#region Properties</p>
<p>public string Port {<br />            get {<br />                return m_sPort;<br />            }<br />            set {<br />                if (m_sPort != value) {<br />                    Close();<br />                    Open(value);<br />                }<br />            }<br />        }</p>
<p>public override bool CanRead {<br />            get {<br />                return m_bRead;<br />            }<br />        }</p>
<p>public override bool CanWrite {<br />            get {<br />                return m_bWrite;<br />            }<br />        }</p>
<p>public override bool CanSeek {<br />            get {<br />                return false;<br />            }<br />        }</p>
<p>public bool Closed  {<br />            get {<br />                return m_hFile.ToInt32()  0;<br />            }<br />        }</p>
<p>public bool Dsr {<br />            get {<br />                uint status;<br />                if (!GetCommModemStatus(m_hFile, out status)) {<br />                    throw new Win32Exception();<br />                }<br />                return (status &amp; MS_DSR_ON) &gt; 0;<br />            }<br />        }</p>
<p>public bool Ring {<br />            get {<br />                uint status;<br />                if (!GetCommModemStatus(m_hFile, out status)) {<br />                    throw new Win32Exception();<br />                }<br />                return (status &amp; MS_RING_ON) &gt; 0;<br />            }<br />        }</p>
<p>public bool Rlsd {<br />            get {<br />                uint status;<br />                if (!GetCommModemStatus(m_hFile, out status)) {<br />                    throw new Win32Exception();<br />                }<br />                return (status &amp; MS_RLSD_ON) &gt; 0;<br />            }<br />        }</p>
<p>#endregion Properties</p>
<p>#region Constructors</p>
<p>public SerialStream() : this(FileAccess.ReadWrite) {<br />        }</p>
<p>public SerialStream(FileAccess access) {<br />            m_bRead  = ((int)access &amp; (int)FileAccess.Read) != 0;<br />            m_bWrite = ((int)access &amp; (int)FileAccess.Write) != 0;<br />            unsafe {<br />                m_IOCompletionCallback = new IOCompletionCallback(AsyncFSCallback);<br />            }<br />        }</p>
<p>public SerialStream(string port) : this(FileAccess.ReadWrite) {<br />            Open(port);<br />        }</p>
<p>public SerialStream(string port, FileAccess access) : this(access) {<br />            Open(port);<br />        }</p>
<p>#endregion Constructors</p>
<p>#region Methods</p>
<p>public void Open(string port) {<br />            if (m_hFile != IntPtr.Zero) {<br />                throw new IOException("Stream already opened.");<br />            }<br />            m_sPort = port;<br />            m_hFile = CreateFile(port, (uint)((m_bRead?GENERIC_READ:0)|(m_bWrite?GENERIC_WRITE:0)), 0, 0, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, 0);<br />            if (m_hFile.ToInt32() == INVALID_HANDLE_VALUE) {<br />                m_hFile = IntPtr.Zero;<br />                throw new FileNotFoundException("Unable to open " + port);<br />            }</p>
<p>ThreadPool.BindHandle(m_hFile);</p>
<p>SetTimeouts(0, 0, 0, 0, 0);<br />        }</p>
<p>public override void Close() {<br />            CloseHandle(m_hFile);<br />            m_hFile = IntPtr.Zero;<br />            m_sPort = null;<br />        }</p>
<p>public IAsyncResult BeginRead(byte[] buffer) {<br />            return BeginRead(buffer, 0, buffer.Length, null, null);<br />        }</p>
<p>public override IAsyncResult BeginRead(byte[] buffer, int offset, int count, AsyncCallback callback, object state) {<br />            GCHandle gchBuffer = GCHandle.Alloc(buffer, GCHandleType.Pinned);<br />            SerialAsyncResult sar = new SerialAsyncResult(this, state, callback, true, gchBuffer);<br />            Overlapped ov = new Overlapped(0, 0, sar.AsyncWaitHandle.Handle.ToInt32(), sar);<br />            unsafe {<br />                NativeOverlapped* nov = ov.Pack(m_IOCompletionCallback);<br />                byte* data = (byte*)((int)gchBuffer.AddrOfPinnedObject() + offset);</p>
<p>uint read = 0;<br />                if (ReadFile(m_hFile, data, (uint)count, out read, nov)) {<br />                    sar.m_bCompletedSynchronously = true;<br />                    return sar;<br />                }<br />                else if (GetLastError() == ERROR_IO_PENDING) {<br />                    return sar;<br />                }<br />                else<br />                    throw new Exception("Unable to initialize read. Errorcode: " + GetLastError().ToString());<br />            }<br />        }</p>
<p>public IAsyncResult BeginWrite(byte[] buffer) {<br />            return BeginWrite(buffer, 0, buffer.Length, null, null);<br />        }</p>
<p>public override IAsyncResult BeginWrite(byte[] buffer, int offset, int count, AsyncCallback callback, object state) {<br />            GCHandle gchBuffer = GCHandle.Alloc(buffer, GCHandleType.Pinned);<br />            SerialAsyncResult sar = new SerialAsyncResult(this, state, callback, false, gchBuffer);<br />            Overlapped ov = new Overlapped(0, 0, sar.AsyncWaitHandle.Handle.ToInt32(), sar);<br />            unsafe {<br />                NativeOverlapped* nov = ov.Pack(m_IOCompletionCallback);<br />                byte* data = (byte*)((int)gchBuffer.AddrOfPinnedObject() + offset);</p>
<p>uint written = 0;<br />                if (WriteFile(m_hFile, data, (uint)count, out written, nov)) {<br />                    sar.m_bCompletedSynchronously = true;<br />                    return sar;<br />                }<br />                else if (GetLastError() == ERROR_IO_PENDING) {<br />                    return sar;<br />                }<br />                else<br />                    throw new Exception("Unable to initialize write. Errorcode: " + GetLastError().ToString());<br />            }<br />        }</p>
<p>private int EndOperation(IAsyncResult asyncResult, bool isRead) {<br />            SerialAsyncResult sar = (SerialAsyncResult)asyncResult;<br />            if (sar.m_bIsRead != isRead)<br />                throw new IOException("Invalid parameter: IAsyncResult is not from a " + (isRead ? "read" : "write"));<br />            if (sar.EndOperationCalled) {<br />                throw new IOException("End" + (isRead ? "Read" : "Write") + " called twice for the same operation.");<br />            }<br />            else {<br />                sar.m_bEndOperationCalled = true;<br />            }</p>
<p>while (!sar.m_bCompleted) {<br />                sar.AsyncWaitHandle.WaitOne();<br />            }</p>
<p>sar.Dispose();</p>
<p>if (sar.m_nErrorCode != ERROR_SUCCESS &amp;&amp; sar.m_nErrorCode != ERROR_OPERATION_ABORTED) {<br />                throw new IOException("Operation finished with errorcode: " + sar.m_nErrorCode);<br />            }</p>
<p>return sar.m_nReadWritten;<br />        }</p>
<p>public override int EndRead(IAsyncResult asyncResult) {<br />            return EndOperation(asyncResult, true);<br />        }</p>
<p>public override void EndWrite(IAsyncResult asyncResult) {<br />            EndOperation(asyncResult, false);<br />        }</p>
<p>public int EndWriteEx(IAsyncResult asyncResult) {<br />            return EndOperation(asyncResult, false);<br />        }</p>
<p>public override int Read(byte[] buffer, int offset, int count) {<br />            return EndRead(BeginRead(buffer, offset, count, null, null));<br />        }</p>
<p>public override void Write(byte[] buffer, int offset, int count) {<br />            EndWrite(BeginWrite(buffer, offset, count, null, null));<br />        }</p>
<p>public int WriteEx(byte[] buffer, int offset, int count) {<br />            return EndWriteEx(BeginWrite(buffer, offset, count, null, null));<br />        }</p>
<p>public int Read(byte[] buffer) {<br />            return EndRead(BeginRead(buffer, 0, buffer.Length, null, null));<br />        }</p>
<p>public int Write(byte[] buffer) {<br />            return EndOperation(BeginWrite(buffer, 0, buffer.Length, null, null), false);<br />        }</p>
<p>public override void Flush() {<br />            FlushFileBuffers(m_hFile);<br />        }</p>
<p>public bool PurgeRead() {<br />            return PurgeComm(m_hFile, PURGE_RXCLEAR);<br />        }</p>
<p>public bool PurgeWrite() {<br />            return PurgeComm(m_hFile, PURGE_TXCLEAR);<br />        }</p>
<p>public bool Purge() {<br />            return PurgeRead() &amp;&amp; PurgeWrite();<br />        }</p>
<p>public bool CancelRead() {<br />            return PurgeComm(m_hFile, PURGE_RXABORT);<br />        }</p>
<p>public bool CancelWrite() {<br />            return PurgeComm(m_hFile, PURGE_TXABORT);<br />        }</p>
<p>public bool CancelAll() {<br />            return CancelRead() &amp;&amp; CancelWrite();<br />        }</p>
<p>public override void SetLength(long nLength) {<br />            throw new NotSupportedException("SetLength isn't supported on serial ports.");<br />        }</p>
<p>public override long Seek(long offset, SeekOrigin origin) {<br />            throw new NotSupportedException("Seek isn't supported on serial ports.");<br />        }</p>
<p>public void SetTimeouts(int ReadIntervalTimeout,<br />                                int ReadTotalTimeoutMultiplier,<br />                                int ReadTotalTimeoutConstant, <br />                                int WriteTotalTimeoutMultiplier,<br />                                int WriteTotalTimeoutConstant) {<br />            SerialTimeouts Timeouts = new SerialTimeouts(ReadIntervalTimeout,<br />                                                         ReadTotalTimeoutMultiplier,<br />                                                         ReadTotalTimeoutConstant, <br />                                                         WriteTotalTimeoutMultiplier,<br />                                                         WriteTotalTimeoutConstant);<br />            unsafe { SetCommTimeouts(m_hFile, ref Timeouts); }<br />        }</p>
<p>public bool SetPortSettings(uint baudrate) {<br />            return SetPortSettings(baudrate, FlowControl.Hardware);<br />        }</p>
<p>public bool SetPortSettings(uint baudrate, FlowControl flowControl) {<br />            return SetPortSettings(baudrate, flowControl, Parity.None);<br />        }</p>
<p>public bool SetPortSettings(uint baudrate, FlowControl flowControl, Parity parity) {<br />            return SetPortSettings(baudrate, flowControl, parity, 8, StopBits.One);<br />        }</p>
<p>public bool SetPortSettings(uint baudrate, FlowControl flowControl, Parity parity, byte databits, StopBits stopbits) {<br />            unsafe {<br />                DCB dcb = new DCB();<br />                dcb.DCBlength = sizeof(DCB);<br />                dcb.BaudRate = baudrate;<br />                dcb.ByteSize = databits;<br />                dcb.StopBits = (byte)stopbits;<br />                dcb.Parity = (byte)parity;<br />                dcb.fParity = (parity &gt; 0)? 1U : 0U;<br />                dcb.fBinary = dcb.fDtrControl = dcb.fTXContinueOnXoff = 1;<br />                dcb.fOutxCtsFlow = dcb.fAbortOnError = (flowControl == FlowControl.Hardware)? 1U : 0U;<br />                dcb.fOutX = dcb.fInX = (flowControl == FlowControl.XOnXOff)? 1U : 0U;<br />                dcb.fRtsControl = (flowControl == FlowControl.Hardware)? 2U : 1U;<br />                dcb.XonLim = 2048;<br />                dcb.XoffLim = 512;<br />                dcb.XonChar = 0x11; // Ctrl-Q<br />                dcb.XoffChar = 0x13; // Ctrl-S<br />                return SetCommState(m_hFile, ref dcb);<br />            }<br />        }</p>
<p>public bool SetPortSettings(DCB dcb) {<br />            return SetCommState(m_hFile, ref dcb);<br />        }</p>
<p>public bool GetPortSettings(out DCB dcb) {<br />            unsafe {<br />                DCB dcb2 = new DCB();<br />                dcb2.DCBlength = sizeof(DCB);<br />                bool ret = GetCommState(m_hFile, ref dcb2);<br />                dcb = dcb2;<br />                return ret;<br />            }<br />        }</p>
<p>public bool SetXOn() {<br />            return EscapeCommFunction(m_hFile, SETXON);<br />        }</p>
<p>public bool SetXOff() {<br />            return EscapeCommFunction(m_hFile, SETXOFF);<br />        }</p>
<p>private unsafe void AsyncFSCallback(uint errorCode, uint numBytes, NativeOverlapped* pOverlapped) {<br />            SerialAsyncResult sar = (SerialAsyncResult)Overlapped.Unpack(pOverlapped).AsyncResult;</p>
<p>sar.m_nErrorCode = errorCode;<br />            sar.m_nReadWritten = (int)numBytes;<br />            sar.m_bCompleted = true;</p>
<p>if (sar.Callback != null)<br />                sar.Callback.Invoke(sar);</p>
<p>Overlapped.Free(pOverlapped);<br />        }</p>
<p>#endregion Methods</p>
<p>#region Constants</p>
<p>private const uint PURGE_TXABORT = 0x0001;  // Kill the pending/current writes to the comm port.<br />        private const uint PURGE_RXABORT = 0x0002;  // Kill the pending/current reads to the comm port.<br />        private const uint PURGE_TXCLEAR = 0x0004;  // Kill the transmit queue if there.<br />        private const uint PURGE_RXCLEAR = 0x0008;  // Kill the typeahead buffer if there.</p>
<p>private const uint SETXOFF  = 1;    // Simulate XOFF received<br />        private const uint SETXON   = 2;    // Simulate XON received<br />        private const uint SETRTS    = 3;    // Set RTS high<br />        private const uint CLRRTS    = 4;    // Set RTS low<br />        private const uint SETDTR    = 5;    // Set DTR high<br />        private const uint CLRDTR    = 6;    // Set DTR low<br />        private const uint SETBREAK    = 8;    // Set the device break line.<br />        private const uint CLRBREAK    = 9;    // Clear the device break line.</p>
<p>private const uint MS_CTS_ON  = 0x0010;<br />        private const uint MS_DSR_ON  = 0x0020;<br />        private const uint MS_RING_ON = 0x0040;<br />        private const uint MS_RLSD_ON = 0x0080;</p>
<p>private const uint FILE_FLAG_OVERLAPPED = 0x40000000;</p>
<p>private const uint OPEN_EXISTING = 3;</p>
<p>private const int  INVALID_HANDLE_VALUE = -1;</p>
<p>private const uint GENERIC_READ = 0x80000000;<br />        private const uint GENERIC_WRITE = 0x40000000;</p>
<p>private const uint ERROR_SUCCESS = 0;<br />        private const uint ERROR_OPERATION_ABORTED = 995;<br />        private const uint ERROR_IO_PENDING = 997;</p>
<p>#endregion Constants</p>
<p>#region Enums</p>
<p>public enum Parity {None, Odd, Even, Mark, Space};<br />        public enum StopBits {One, OneAndHalf, Two};<br />        public enum FlowControl {None, XOnXOff, Hardware};</p>
<p>#endregion Enums</p>
<p>#region Classes</p>
<p>[StructLayout(LayoutKind.Sequential)]<br />        public struct DCB {</p>
<p>#region Attributes</p>
<p>public int DCBlength;<br />            public uint BaudRate;<br />            public uint Flags;<br />            public ushort wReserved;<br />            public ushort XonLim;<br />            public ushort XoffLim;<br />            public byte ByteSize;<br />            public byte Parity;<br />            public byte StopBits;<br />            public sbyte XonChar;<br />            public sbyte XoffChar;<br />            public sbyte ErrorChar;<br />            public sbyte EofChar;<br />            public sbyte EvtChar;<br />            public ushort wReserved1;</p>
<p>#endregion Attributes</p>
<p>#region Properties</p>
<p>public uint fBinary { get { return Flags&amp;0x0001; } <br />                                  set { Flags = Flags &amp; ~1U | value; } }<br />            public uint fParity { get { return (Flags&gt;&gt;1)&amp;1; }<br />                                  set { Flags = Flags &amp; ~(1U &gt;2)&amp;1; }<br />                                  set { Flags = Flags &amp; ~(1U &gt;3)&amp;1; }<br />                                  set { Flags = Flags &amp; ~(1U &gt;4)&amp;3; }<br />                                  set { Flags = Flags &amp; ~(3U &gt;6)&amp;1; }<br />                                  set { Flags = Flags &amp; ~(1U &gt;7)&amp;1; }<br />                                  set { Flags = Flags &amp; ~(1U &gt;8)&amp;1; }<br />                                  set { Flags = Flags &amp; ~(1U &gt;9)&amp;1; }<br />                                  set { Flags = Flags &amp; ~(1U &gt;10)&amp;1; }<br />                                  set { Flags = Flags &amp; ~(1U &gt;11)&amp;1; }<br />                                  set { Flags = Flags &amp; ~(1U &gt;12)&amp;3; }<br />                                  set { Flags = Flags &amp; ~(3U &gt;14)&amp;1; }<br />                                  set { Flags = Flags &amp; ~(1U &lt;&lt; 14) | (value &lt;&lt; 14); } }</p>
<p>#endregion Properties</p>
<p>#region Methods</p>
<p>public override string ToString() {<br />                return "DCBlength: " + DCBlength + "\r\n" +<br />                    "BaudRate: " + BaudRate + "\r\n" +<br />                    "fBinary: " + fBinary + "\r\n" +<br />                    "fParity: " + fParity + "\r\n" +<br />                    "fOutxCtsFlow: " + fOutxCtsFlow + "\r\n" +<br />                    "fOutxDsrFlow: " + fOutxDsrFlow + "\r\n" +<br />                    "fDtrControl: " + fDtrControl + "\r\n" +<br />                    "fDsrSensitivity: " + fDsrSensitivity + "\r\n" +<br />                    "fTXContinueOnXoff: " + fTXContinueOnXoff + "\r\n" +<br />                    "fOutX: " + fOutX + "\r\n" +<br />                    "fInX: " + fInX + "\r\n" +<br />                    "fErrorChar: " + fErrorChar + "\r\n" +<br />                    "fNull: " + fNull + "\r\n" +<br />                    "fRtsControl: " + fRtsControl + "\r\n" +<br />                    "fAbortOnError: " + fAbortOnError + "\r\n" +<br />                    "XonLim: " + XonLim + "\r\n" +<br />                    "XoffLim: " + XoffLim + "\r\n" +<br />                    "ByteSize: " + ByteSize + "\r\n" +<br />                    "Parity: " + Parity + "\r\n" +<br />                    "StopBits: " + StopBits + "\r\n" +<br />                    "XonChar: " + XonChar + "\r\n" +<br />                    "XoffChar: " + XoffChar + "\r\n" +<br />                    "EofChar: " + EofChar + "\r\n" +<br />                    "EvtChar: " + EvtChar + "\r\n";<br />            }</p>
<p>#endregion Methods<br />        }</p>
<p>private class SerialAsyncResult : IAsyncResult, IDisposable {</p>
<p>#region Attributes</p>
<p>internal bool m_bEndOperationCalled = false;<br />            internal bool m_bIsRead;<br />            internal int m_nReadWritten = 0;<br />            internal bool m_bCompleted = false;<br />            internal bool m_bCompletedSynchronously = false;<br />            internal uint m_nErrorCode = ERROR_SUCCESS;</p>
<p>private object m_AsyncObject;<br />            private object m_StateObject;<br />            private ManualResetEvent m_WaitHandle = new ManualResetEvent(false);<br />            private AsyncCallback m_Callback;<br />            private GCHandle m_gchBuffer;</p>
<p>#endregion Attributes</p>
<p>#region Properties</p>
<p>internal bool EndOperationCalled { get { return m_bEndOperationCalled; } }</p>
<p>public bool IsCompleted { get { return m_bCompleted; } }</p>
<p>public bool CompletedSynchronously { get { return m_bCompletedSynchronously; } }</p>
<p>public object AsyncObject { get { return m_AsyncObject; } }</p>
<p>public object AsyncState { get { return m_StateObject; } }</p>
<p>public WaitHandle AsyncWaitHandle { get { return m_WaitHandle; } }<br />            internal ManualResetEvent WaitHandle { get { return m_WaitHandle; } }</p>
<p>public AsyncCallback Callback { get { return m_Callback; } }</p>
<p>#endregion Properties</p>
<p>#region Constructors</p>
<p>public SerialAsyncResult(object asyncObject,<br />                object stateObject, <br />                AsyncCallback callback, <br />                bool bIsRead, <br />                GCHandle gchBuffer) {</p>
<p>m_AsyncObject = asyncObject;<br />                m_StateObject = stateObject;<br />                m_Callback = callback;<br />                m_bIsRead = bIsRead;<br />                m_gchBuffer = gchBuffer;<br />            }</p>
<p>#endregion Constructors</p>
<p>#region Methods</p>
<p>public void Dispose() {<br />                m_WaitHandle.Close();<br />                m_gchBuffer.Free();<br />            }</p>
<p>#endregion Methods<br />        }</p>
<p>#endregion Classes</p>
<p>#region Imports</p>
<p>[DllImport("kernel32.dll", EntryPoint="CreateFileW",  SetLastError=true,<br />            CharSet=CharSet.Unicode, ExactSpelling=true)]<br />        static extern IntPtr CreateFile(string filename, uint access, uint sharemode, uint security_attributes, uint creation, uint flags, uint template);</p>
<p>[DllImport("kernel32.dll", SetLastError=true)]<br />        static extern bool CloseHandle(IntPtr handle);</p>
<p>[DllImport("kernel32.dll", SetLastError=true)]<br />        static extern unsafe bool ReadFile(IntPtr hFile, byte* lpBuffer, uint nNumberOfBytesToRead, out uint lpNumberOfBytesRead, NativeOverlapped* lpOverlapped);</p>
<p>[DllImport("kernel32.dll", SetLastError=true)]<br />        static extern unsafe bool WriteFile(IntPtr hFile, byte* lpBuffer, uint nNumberOfBytesToWrite, out uint lpNumberOfBytesWritten, NativeOverlapped* lpOverlapped);</p>
<p>[DllImport("kernel32.dll", SetLastError=true)]<br />        static extern bool SetCommTimeouts(IntPtr hFile, ref SerialTimeouts lpCommTimeouts);</p>
<p>[DllImport("kernel32.dll", SetLastError=true)]<br />        static extern bool SetCommState(IntPtr hFile, ref DCB lpDCB);</p>
<p>[DllImport("kernel32.dll", SetLastError=true)]<br />        static extern bool GetCommState(IntPtr hFile, ref DCB lpDCB);</p>
<p>[DllImport("kernel32.dll", SetLastError=true)]<br />        static extern bool BuildCommDCB(string def, ref DCB lpDCB);</p>
<p>[DllImport("kernel32.dll", SetLastError=true)]<br />        static extern int GetLastError();</p>
<p>[DllImport("kernel32.dll", SetLastError=true)]<br />        static extern bool FlushFileBuffers(IntPtr hFile);</p>
<p>[DllImport("kernel32.dll", SetLastError=true)]<br />        static extern bool PurgeComm(IntPtr hFile, uint dwFlags);</p>
<p>[DllImport("kernel32.dll", SetLastError=true)]<br />        static extern bool EscapeCommFunction(IntPtr hFile, uint dwFunc);</p>
<p>[DllImport("kernel32.dll", SetLastError=true)]<br />        static extern bool GetCommModemStatus(IntPtr hFile, out uint modemStat);</p>
<p>#endregion Imports<br />    }</p>
<p>[StructLayout(LayoutKind.Sequential)]<br />    public struct SerialTimeouts {</p>
<p>#region Attributes</p>
<p>public int ReadIntervalTimeout;<br />        public int ReadTotalTimeoutMultiplier;<br />        public int ReadTotalTimeoutConstant;<br />        public int WriteTotalTimeoutMultiplier;<br />        public int WriteTotalTimeoutConstant;</p>
<p>#endregion Attributes</p>
<p>#region Constructors</p>
<p>public SerialTimeouts(int r1, int r2, int r3, int w1, int w2) {<br />            ReadIntervalTimeout = r1;<br />            ReadTotalTimeoutMultiplier = r2;<br />            ReadTotalTimeoutConstant = r3;<br />            WriteTotalTimeoutMultiplier = w1;<br />            WriteTotalTimeoutConstant = w2;<br />        }</p>
<p>#endregion Constructors</p>
<p>#region Methods</p>
<p>public override string ToString() {<br />            return "ReadIntervalTimeout: " + ReadIntervalTimeout + "\r\n" +<br />                   "ReadTotalTimeoutMultiplier: " + ReadTotalTimeoutMultiplier + "\r\n" +<br />                   "ReadTotalTimeoutConstant: " + ReadTotalTimeoutConstant + "\r\n" +<br />                   "WriteTotalTimeoutMultiplier: " + WriteTotalTimeoutMultiplier + "\r\n" +<br />                   "WriteTotalTimeoutConstant: " + WriteTotalTimeoutConstant + "\r\n";<br />        }</p>
<p>#endregion Methods<br />    }<br />}</p>
<p>using System;<br />using System.IO;<br />using System.Threading;</p>
<p>using LoMaN.IO;</p>
<p>namespace SerialStreamReader {</p>
<p>class App {</p>
<p>// The main serial stream<br />        static SerialStream ss;</p>
<p>[STAThread]<br />        static void Main(string[] args) {</p>
<p>// Create a serial port<br />            ss = new SerialStream();<br />            try {<br />                ss.Open("COM4"); //我对猫进行了调用<br />            }<br />            catch (Exception e) {<br />                Console.WriteLine("Error: " + e.Message);<br />                return;<br />            }</p>
<p>// Set port settings<br />            ss.SetPortSettings(9600);</p>
<p>// Set timeout so read ends after 20ms of silence after a response<br />            ss.SetTimeouts(20, 0, 0, 0, 0);</p>
<p>// Create the StreamWriter used to send commands<br />            StreamWriter sw = new StreamWriter(ss, System.Text.Encoding.ASCII);</p>
<p>// Create the Thread used to read responses<br />            Thread responseReaderThread = new Thread(new ThreadStart(ReadResponseThread));<br />            responseReaderThread.Start();</p>
<p>// Read all returned lines<br />            for (;;) {<br />                // Read command from console<br />                string command = Console.ReadLine();</p>
<p>// Check for exit command<br />                if (command.Trim().ToLower() == "exit") {<br />                    responseReaderThread.Abort();<br />                    break;<br />                }</p>
<p>// Write command to modem<br />                sw.WriteLine(command);<br />                sw.Flush();<br />            }<br />        }</p>
<p>// Main loop for reading responses<br />        static void ReadResponseThread() {<br />            StreamReader sr = new StreamReader(ss, System.Text.Encoding.ASCII);<br />            try {<br />                for (;;) {<br />                    // Read response from modem<br />                    string response = sr.ReadLine();<br />                    Console.WriteLine("Response: " + response);<br />                }<br />            }<br />            catch (ThreadAbortException) {<br />            }<br />        }<br />    }<br />}</p>
<p>程序运行后，你可以对设备进行指令操作。（具体设备接受的指令）</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-09 16:02:25</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/public/" title="public">public</a>, <a href="https://www.iamivan.net/tag/return/" title="return">return</a>, <a href="https://www.iamivan.net/tag/private/" title="private">private</a>, <a href="https://www.iamivan.net/tag/const/" title="const">const</a>, <a href="https://www.iamivan.net/tag/bool/" title="bool">bool</a>, <a href="https://www.iamivan.net/tag/buffer/" title="buffer">buffer</a>, <a href="https://www.iamivan.net/tag/%e6%91%84%e5%83%8f%e5%a4%b4ov9650/" title="摄像头ov9650">摄像头ov9650</a>, <a href="https://www.iamivan.net/tag/ov3640/" title="ov3640">ov3640</a>, <a href="https://www.iamivan.net/tag/throw-bool-c/" title="throw bool c&num;">throw bool c&num;</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>C#串口操作(国外网站看来的，共享一下)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/apXOAKM.html" rel="bookmark">网站前端开发者必去的10个国外网站</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Web开发者目前主要分为前端和后端,本文收集的10个国外网站主要针对网站前端开发,里面包括浏览器兼容性检测.JS脚本下载.CSS小工具,网页测试.PHP与MYSQL等.都很实用 对我们这些Web开发者来说,不计其数的网站,其中有些对我们来说是相当有用的工具.在本文 中,我汇编了10个顶有用的网站,可以说每个开发者都应当将这些网站存为自己的书签. Mysql Format Date MySQL Format Date允许你利用MySQL DATE_FORMA函数规范化你的日期数值.只须挑选一个通用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mg3ZO8M.html" rel="bookmark">如何使用Readability正常浏览国外网站全文</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用Https的Google Reader可以浏览国外网站的RSS文章,但不少网站是非全文RSS.Yahoo pipes或Full-Text RSS类第三方工具强制获取网站的全文RSS总是不完美.Yahoo pipes抓取操作复杂,Full-Text RSS类网站操作简单,但持久性不足.Readability本来是定位于专注阅读,但可以通过其正常浏览国外网站全文. Readability 什么是Readability,这个没有什么好介绍的,已经出来有一段时间了.其主要功能就是将任意网站的文章自动			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRN8eeM.html" rel="bookmark">总结提高国外网站访问速度的几个技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 无疑站长也是经常去访问国外网站的群体之一,下面奉上国外网站访问大提速技巧帮各位站长节省时间. DNS服务器的主要作用就是解析域名,它就像一个翻译官,当我们从浏览器地址栏发送网址时,首先要通过它将网址转换成真实的IP地址才能访问站点.所以作为中间人,DNS服务器的反应速度也会影响上网速度. 我们知道,DNS解析也是决定网速快慢的一个很大原因.如			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnOK2jz.html" rel="bookmark">Bing等多家国外网站无法访问</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 计世网消息(智超) 6月2日刚刚上线的微软搜索品牌&quot;必应&quot;(包括中文版cn.bing.com)于昨晚开始无法访问. 据网友反映,北京时间下午开始,多家国外的知名网站发生大面积访问故障,或&quot;连接超时&quot;,或&quot;连接被重置&quot;.这些网站包括照片共享网站flickr,著名微博客服务twitter			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrdAOVz.html" rel="bookmark">CentOS配置Shadowsocks代理服务器浏览国外网站例子</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				说明: Shadowsocks是一个轻量级的socks5代理软件, 而hadowsocks-libev是一个基于shadowsocks 协议的socks5代理软件, 相比原版,hadowsocks-libev程序体积小.高并发.资源占用更少.跨平台.完全兼容shadowsocks协议. hadowsocks-libev包括三个模块: ss-server:服务器端,部署在远程服务器,提供shadowsocks服务. ss-local:客户端,提供本地socks5协议代理. ss-redir:客户端			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9ze4d9p.html" rel="bookmark">我用了共享内存映射，但是，串口来的数写到共享内存里，就是更新不到磁盘文件里去咋办？？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 我用了共享内存映射,但是,串口来的数写到共享内存里,就是更新不到磁盘文件里去咋办?? 共享内存映射,flushviewoffile,更新磁盘文件(那个flushviewoffile 返回都是对的可是文件里就是没有东西) 解决方案 先看i数据是否正确接收了,有没有写入共享内存.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XpmENDp.html" rel="bookmark">国外网站设计资源推荐</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				国外网站|设计|设计资源 CSS库 做设计的时候总是容易没有灵感.到CSS库去看看别人做得设计也许会帮你找到不少灵感.如果你的设计足够优秀让这些CSS库收录的话,那么这还会为你带来很多访问者 Unmatchedstyle cssBeauty cssvault Stylegala CSS Drive css thesis Styleboost CSSElite CSS Import Web Creme CSS Mania DesignShack  Web标准 遵守Web标准来编写代码会使你的代码干			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/6b3LqmM.html" rel="bookmark">C&num;异步数据接收串口操作类</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				数据|异步 使用C#调用传统32位API实现串口操作,整个结构特别的简单.接收数据只需要定义数据接收事件即可. 上传源代码我不会,需要源代码的请与我(dyj057@gmail.com)联系.你也可以教我怎么上传源代码. using System;using System.Runtime.InteropServices; /// &lt;summary&gt;/// (C)2003-2005 C2217 Studio 保留所有权利/// /// 文件名称: IbmsSerialPort.cs/// 文件ID			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnxEaAb.html" rel="bookmark">VC&num;串口操作实用类</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				做工业通信有很长时间了,特别是串口(232/485),有VB/VC/C各种版本的串口操作代码,这些代码也经过了多年的现场考验,应该说是比较健壮的代码,但是目前却没有C#相对成熟的串口操作代码,最近用Moxa的设备开发基于WinCE5.0的串口操作代码,所以就扩充完善了一下串口操作,特别是SendCommand函数,这是我比较常用的主从通信代码,不喜欢用事件或线程接数据,在规定的超时时间内直接循环判断要接收的数据. 下面是具体的代码: public class PortData { public			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybj5e0z.html" rel="bookmark" class="title">市场需要培育，关键字优化需要耐心</a>
					<div>
						做关键字优化的工作,其实更需要坚持与耐心. 在以前由于搜索引擎的不完善,有不少漏洞可钻,譬如最早期的关键字密度,密度越高,然后排名相对越好,于是出现了不少文章就是靠堆关键字做出了排名,一篇文章竟然可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKrw7z.html" rel="bookmark" class="title">实战PHP&sol;GTK&lpar;转载&rpar;</a>
					<div>
						实战PHP/GTK(转载) 刁馋 发表于 2002-2-19 15:25 PHP编程 ←返回版面      以前PHP被认为只能用来编写服务器端的CGI程序,如果说PHP能够开发Windows下的GU ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVvqVz.html" rel="bookmark" class="title">C&plus;&plus;中数据对齐问题：struct、union、enum。再谈sizeof&lpar;&rpar;</a>
					<div>
						首先是struct,在C++中,结构体其实和class有很大的相似了.但是有一点不同的是,struct默认是public,而class中是private. 当然,struct继承等用法也是可以的. 共 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRK9qz.html" rel="bookmark" class="title">windows2000秘密武器之内存工具</a>
					<div>
						4. 内存快照 这个工具可以将所有内存资源的消耗情况写进一个日志文件中, 供以后分析使用,有点类似＂快照＂的方式．日志文件使用的默认名字是Memsnap.log,当然在建立这个日志文件时,也可以用其它 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPaVyM.html" rel="bookmark" class="title">利用XML序列化实现程序配置文件</a>
					<div>
						 有些应用程序在退出的时候,会将一些设置值写入到文件里,以便下次程序启动时调用,这个文件统称为配置文件.例如:Windows的扫雷程序,在每次启动的时候,都会出现在上次关闭的位置,就是因为扫雷程序在退 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg30qmM.html" rel="bookmark" class="title">windows8系统轻松锁屏技巧</a>
					<div>
						  windows8系统轻松锁屏技巧:安装了win8系统的用户都会知道,每次启动Win8的登录界面屏幕便会被一副背景的图片锁住,不熟悉Win8系统的用户可能会傻傻地在干等,其实Win8可以像我们的手机 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z421wYM.html" rel="bookmark" class="title">win7系统开机出现cdmsnroot s&period;sys的修复方法</a>
					<div>
						  一些用户在使用win7操作系统时,由遭受病毒或系统文件丢失会出现各种各类的错误提示,就如小编今天遇到win7系统开机出现cdmsnroot s.sys文件错误的问题,对于该问题小编经过查找发现,是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmG1n5b.html" rel="bookmark" class="title">java 客户端 服务器-java客户端和服务器通信</a>
					<div>
						问题描述 java客户端和服务器通信 1C try{ Socket s=new Socket(&quot;&quot;127.0.0.1&quot;&quot;9997); System.out.pr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mxodjjb.html" rel="bookmark" class="title">JavaScript读取中文cookie时的乱码问题的解决方法&lowbar;javascript技巧</a>
					<div>
						复制代码 代码如下: function Get_Cookie(name) { var start = document.cookie.indexOf(name+-=-); var len = star ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPP11vp.html" rel="bookmark" class="title">四位计算机的原理及其实现</a>
					<div>
						你是否想过,计算机为什么会加减乘除?或者更直接一点,计算机的原理到底是什么? Waitingforfriday有一篇详细的教程,讲解了如何自己动手,制作一台四位计算机.从中可以看到,二进制.数理逻辑. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6Lyqz.html" rel="bookmark" class="title">oracle 索引</a>
					<div>
						在关系数据库中,索引是一种与表有关的数据库结构,它可以使对应于表的SQL语句执行得更快.索引的作用相当于图书的目录,可以根据目录中的页码快速找到所需的内容.  对于数据库来说,索引是一个必选项,但对于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQ9nLp.html" rel="bookmark" class="title">刘谦低调投资卖鞋网站 称押宝互联网是长久心愿</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 刘谦,唯一曾受邀至拉斯维加斯及好莱 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQYY8z.html" rel="bookmark" class="title">angularjs-AngularJS 按钮控制一组控件的增减</a>
					<div>
						问题描述 AngularJS 按钮控制一组控件的增减 用AngularJS做前端,页面和前端的ctrl 在同一页面有&quot;+&quot;&quot;-&quot;两个按钮 来控制一组控件的增减  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PGmop.html" rel="bookmark" class="title">MyBatis Generator 详解&lpar;good&rpar;</a>
					<div>
						idea中有plugin可提高效率: http://www.henryxi.com/use-idea-mybatis-plugin-generate-mapper-files eg: &lt;?xml ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVNgVYz.html" rel="bookmark" class="title">Posix信号量</a>
					<div>
						1.概述 信号量(semaphore)是一种用于提供不同进程间或一个给定进程的不同线程间同步手段的原语.信号量的使用主要是用来保护共享资源,使得资源在一个时刻只有一个进程(线程)所拥有.信号量的值为正 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7KxPp.html" rel="bookmark" class="title">图片-请问这个问题怎么解决？</a>
					<div>
						问题描述 请问这个问题怎么解决? 我的数据库里有&quot;病案号&quot;这一列.从弹出的对话框指出是cellclick出错.到底是我的代码有问题还是数据库? 解决方案 其实这个问题 排查起来很简 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnK44Oz.html" rel="bookmark" class="title">软件蚕食世界，创业公司变全能</a>
					<div>
						摘要: Andreessen Horowitz(A16Z)是硅谷最顶尖的风投公司之一,几乎每一笔重大的技术融资都会有这家VC的身影,以至于引发了所谓的Andreessen Horowitz效应.现在, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rj8xp.html" rel="bookmark" class="title">15 个实用的 PHP 正则表达式</a>
					<div>
						对于开发人员来说,正则表达式是一个非常有用的功能,它提供了 查找,匹配,替换 句子,单词,或者其他格式的字符串.这篇文章主要介绍了15个超实用的php正则表达式,需要的朋友可以参考下.在这篇文章里,我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPB120b.html" rel="bookmark" class="title">【iOS7的一些总结】8、破解UIView中坐标系的秘密：关于UIView中的frame、bound和center</a>
					<div>
						对于刚刚接触iOS开发不久的新手来说,UIView中的frame.bound和center的确容易产生思维的误区,尤其是想要对视图类的bound这个概念若想要理解深入,真的要花一番功夫.在经过一系列查 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZG0rp.html" rel="bookmark" class="title">编程-hex16进制转换把EXE转换成文本，那如何转换回来？</a>
					<div>
						问题描述 hex16进制转换把EXE转换成文本,那如何转换回来? 一个16kb的exe软件,通过hex转换成16进制的一堆字符例如0x40165.....这些字符是文本格式,现在这么把一堆字符重新转换 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJA6A7p.html" rel="bookmark" class="title">解析javascript 浏览器关闭事件&lowbar;javascript技巧</a>
					<div>
						复制代码 代码如下: &lt;script type=&quot;text/javascript&quot;&gt;      window.onbeforeunload = onbeforeunlo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY57oeM.html" rel="bookmark" class="title">在Docker Swarm模式下，Docker应用如何实现服务发现</a>
					<div>
						本文讲的是在Docker Swarm模式下,Docker应用如何实现服务发现[编者的话]无论容器是否存在于集群之中,本文将告诉我们如何可靠地连接到它.  [深圳站|3天烧脑式Kubernetes训练营 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Z9aKp.html" rel="bookmark" class="title">关于系统性能测试的步骤总结和分析</a>
					<div>
						关于系统性能测试的步骤总结和分析 近期接触的项目,进行了比较多的性能测试,就性能测试的步骤做一下总结和分析,也希望对以后的工作有益. 性能测试,是一种&quot;正常&quot;的测试,主要是测试正常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRKkkp.html" rel="bookmark" class="title">SQL之left join、right join、inner join的区别浅析&lowbar;数据库其它</a>
					<div>
						今天和某朋友聊天,谈到他们公司的一个小问题.如下: 表A设备表,存储MAC地址,省份,城市,区. 表B软件表,存储MAC地址,软件名字. 功能是可以按省份,城市,或者区来查询软件列表. 你猜它现在如何 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7BAez.html" rel="bookmark" class="title">电信推Wi-Fi促销 移动联通用户每月免费2小时</a>
					<div>
						9月13日消息,中国电信宣布,从即日起至12月31日,天翼手机用户每月赠送10小时免费WiFi上网,而中国移动和联通用户每月也可申请2小时连续WiFi上网体验. 据悉,中国电信用户如原来享受一定时长的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwAq8M.html" rel="bookmark" class="title">广东环市东花果山将建移动互联网产业基地</a>
					<div>
						南都讯 记者 吴广宇 通讯员 杨亚明 花果山即将迎来新主人,不是美猴王,而是越秀区移动互联网产业基地. 越秀区副区长卞勇昨日表示,按照&lt;越秀区移动互联网产业发展规划&gt;,该区将结合&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmV4njz.html" rel="bookmark" class="title">Android获取当前运行的类名或者方法&lowbar;Android</a>
					<div>
						本文实例讲述了Android获取当前运行的类名或者方法.分享给大家供大家参考.具体实现方法如下: public static String getCurrentMethodName() { int l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvPW4M.html" rel="bookmark" class="title">在代码中如何使用Word的CommandBars</a>
					<div>
						问题描述 在代码中如何使用Word的CommandBars我一个在WinForm使用Word,引用了Office11ObjectLibrary(MSO.DLL)和Word11ObjectLibrary ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEGAZz.html" rel="bookmark" class="title">给&OpenCurlyDoubleQuote;添加&sol;删除程序&rdquo; 增加&OpenCurlyDoubleQuote;网络安装&rdquo;选项卡</a>
					<div>
						本人是一所普通中学的机房管理员,在http://www.aliyun.com/zixun/aggregation/6988.html&quot;&gt;日常管理中最头痛的问题就是机房常用软件的安装.在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jOvkp.html" rel="bookmark" class="title">求开发一个小系统步骤&period;&period;&period;&period;&period;</a>
					<div>
						问题描述 在ASP.NET平台上用才c#语言开发一个小系统(因为是期末作业,系统不是大,就是一个小型的),后台数据库采用SQLService2000,求解开发步骤,在下初学,望高手多多指教. 解决方案 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.039 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
